/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_syssvc.h 8 2008-05-24 17:11:12Z roi $
 */

/*
 *		ƥॵӥΥץå¸H8/300Hѡ
 *
 *  ƥॵӥΥåȰ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե
 *  ̵ʤ븫ߡ
 */

#ifndef TOPPERS_CORE_SYSSVC_H
#define TOPPERS_CORE_SYSSVC_H

#include <sil.h>

/**************************************************************
 *  SIL黻ĥ
 *  
 *  ѥηåǽͭˤ뤿ᡢݥ󥿷
 *  uint8_t *uint16_t *uint32_t *ѤƤ롣
 **************************************************************/

/*
 *  8ӥåȥ쥸AND黻
 */
Inline void
h8_anb_reg(uint8_t *p_mem, uint8_t data)
{
        uint8_t reg = sil_reb_mem((void *)p_mem);
        reg &= data;
        sil_wrb_mem((void *)p_mem, reg);
}

/*
 *  8ӥåȥ쥸OR黻
 */
Inline void
h8_orb_reg(uint8_t *p_mem, uint8_t data)
{
        uint8_t reg = sil_reb_mem((void *)p_mem);
        reg |= data;
        sil_wrb_mem((void *)p_mem, reg);
}


/*
 *  16ӥåȥ쥸AND黻
 */
Inline void
h8_anh_reg(uint16_t *p_mem, uint16_t data)
{
        uint16_t reg = sil_reh_mem((void *)p_mem);
        reg &= data;
        sil_wrh_mem((void *)p_mem, reg);
}

/*
 *  16ӥåȥ쥸OR黻
 */
Inline void
h8_orh_reg(uint16_t *p_mem, uint16_t data)
{
        uint16_t reg = sil_reh_mem((void *)p_mem);
        reg |= data;
        sil_wrh_mem((void *)p_mem, reg);
}

/*
 *  32ӥåȥ쥸AND黻
 */
Inline void
h8_anw_reg(uint32_t *p_mem, uint32_t data)
{
        uint32_t reg = sil_rew_mem((void *)p_mem);
        reg &= data;
        sil_wrw_mem((void *)p_mem, reg);
}

/*
 *  32ӥåȥ쥸OR黻
 */
Inline void
h8_orw_reg(uint32_t *p_mem, uint32_t data)
{
        uint32_t reg = sil_rew_mem((void *)p_mem);
        reg |= data;
        sil_wrw_mem((void *)p_mem, reg);
}

/*
 *DDRֹ
 *
 *ΥǥåѤ롣
 *ʤݡ7ѤDDR쥸ʤᡢάƤ롣
 */
enum T_IO_PORT {
	IO_PORT1,
	IO_PORT2,
	IO_PORT3,
	IO_PORT4,
	IO_PORT5,
	IO_PORT6,
	IO_PORT8,
	IO_PORT9,
	IO_PORTA,
	IO_PORTB
};

typedef enum T_IO_PORT IO_PORT;

/*
 *I/OݡȤΥǡǥ쥯󡦥쥸DDRؤΥ
 *
 *H8DDRϽ񤭹ѤǤꡢΤޤޤǤϽ˾ΥӥåȤ
 *ѹ뤳ȤǤʤbset,bclr̿ǤԲġ
 *ΤᡢܼǤϡ˥ƥݥѰդơDDR
 *ͤݻˡΤäƤ롣
 */
extern uint8_t sil_reb_ddr(IO_PORT port) throw();
extern void sil_wrb_ddr(IO_PORT port, uint8_t data) throw();
extern void sil_anb_ddr(IO_PORT port, uint8_t data) throw();
extern void sil_orb_ddr(IO_PORT port, uint8_t data) throw();

#endif /* TOPPERS_CORE_SYSSVC_H */
