/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2008 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: h8300.h 847 2008-05-24 17:22:24Z roi $
 */

#ifndef TOPPERS_H8300H_H_
#define TOPPERS_H8300H_H_

/*
 *  H8/300H 
 */

/*
 *  ͥǡʸѥޥ
 */


/* Condition Code Register (CCR) */
#define H8CCR_I_BIT		UINT8_C(7)
#define H8CCR_UI_BIT	UINT8_C(6)
#define H8CCR_H_BIT		UINT8_C(5)
#define H8CCR_U_BIT		UINT8_C(4)
#define H8CCR_N_BIT		UINT8_C(3)
#define H8CCR_Z_BIT		UINT8_C(2)
#define H8CCR_V_BIT		UINT8_C(1)
#define H8CCR_C_BIT		UINT8_C(0)

#define H8CCR_I			(UINT8_C(1) << H8CCR_I_BIT)
#define H8CCR_UI		(UINT8_C(1) << H8CCR_UI_BIT)
#define H8CCR_H			(UINT8_C(1) << H8CCR_H_BIT)
#define H8CCR_U			(UINT8_C(1) << H8CCR_U_BIT)
#define H8CCR_N			(UINT8_C(1) << H8CCR_N_BIT)
#define H8CCR_Z			(UINT8_C(1) << H8CCR_Z_BIT)
#define H8CCR_V			(UINT8_C(1) << H8CCR_V_BIT)
#define H8CCR_C			(UINT8_C(1) << H8CCR_C_BIT)

/*
 * CCRIӥåȤUIӥåȤߥޥӥåȤȤƻѤ롣
 *   IIPMIPMɽˤϥͥ٥CPUå˻ѤΤФ
 *   ΥޥOSʤǤSILʤɡ˥ץå٥ǻѤ롣
 *   ʥͥγߤޤफޤޤʤΰ㤤
 */
#define H8INT_MASK_ALL	(H8CCR_I | H8CCR_UI)

#define H8INT_DIS_ALL	H8INT_MASK_ALL
#define H8INT_ENA_ALL	(0xff & ~(H8INT_MASK_ALL))

#define H8DISINT_ALL	UINT8_C(H8INT_DIS_ALL)	/*  IӥåȤUIӥåȤΤ1  */
#define H8ENAINT_ALL	UINT8_C(H8INT_ENA_ALL)	/*  IӥåȤUIӥåȤΤ0  */

/*  IӥåȤUIӥåȤФޥ  */
#define H8CCR_INT_MASK_BIT		UINT8_C(0xc0)

#ifndef TOPPERS_MACRO_ONLY
/*
 *  IIPMʳߥޥɽˤη
 */
typedef uint8_t	IIPM;
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_AT91SAM7S_H */
