/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2007 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Kunihiko Ohnaka
 *  Copyright (C) 2008 GJ Designing Center Printer Business Group
 *                                          RICOH COMPANY,LTD. JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: h8_3069f.h,v 1.4 2008/05/24 18:25:15 roi Exp $
 */

#ifndef TOPPERS_H8_3069F_H_
#define TOPPERS_H8_3069F_H_

/*
 *  H8/3069F 
 */

/*  ֹκ  */
#define TMAX_INTNO			64U

/*  IRQֹ(intno)κ/Ǿ  */
#define TMAX_INTNO_IRQ		17U
#define TMIN_INTNO_IRQ		12U

/*  IRQֹκ  */
#define TMAX_IRQ_NO			5U

/*  IPRA쥸ǳߥ٥Ǥֹκ  */
#define TMAX_INTNO_IPRA		34U




/* Interrupt numbers */

#define TINTNO_NMI			 7U		/* NMI */

#define TINTNO_TRAP8		 8U

#define TINTNO_IRQ0			12U		/* IRQ0 */
#define TINTNO_IRQ1			13U		/* IRQ1 */
#define TINTNO_IRQ2			14U		/* IRQ2 */
#define TINTNO_IRQ3			15U		/* IRQ3 */
#define TINTNO_IRQ4			16U		/* IRQ4 */
#define TINTNO_IRQ5			17U		/* IRQ5 */

#define TINTNO_WOVI         20U     /* Watch Doc Timer */

#define TINTNO_CMI          21U     /* Compare Match */

#define TINTNO_ADI			23U		/* A/D */

#define TINTNO_IMIA0        24U     /* ITU0 IMIA0 */
#define TINTNO_IMIB0        25U     /* ITU0 IMIB0 */
#define TINTNO_OVI0         26U     /* ITU0 OVI0  */

#define TINTNO_IMIA1        28U     /* ITU1 IMIA1 */
#define TINTNO_IMIB1        29U     /* ITU1 IMIB1 */
#define TINTNO_OVI1         30U     /* ITU1 OVI1  */

#define TINTNO_IMIA2        32U     /* ITU2 IMIA2 */
#define TINTNO_IMIB2        33U     /* ITU2 IMIB2 */
#define TINTNO_OVI2         34U     /* ITU2 OVI2  */

#define TINTNO_CIMIA0		36U		/* 8 bit timer 0 CIMIA0 */
#define TINTNO_CIMIB0		37U		/* 8 bit timer 0 CIMIB0 */
#define TINTNO_CIMIA1		38U		/* 8 bit timer 1 CIMIA1 */
#define TINTNO_CIMIB1		38U		/* 8 bit timer 1 CIMIB1 */
#define TINTNO_TOVI0		39U		/* 8 bit timer 0 TOVI0  */
#define TINTNO_TOVI1		39U		/* 8 bit timer 1 TOVI1  */

#define TINTNO_CIMIA2		40U		/* 8 bit timer 2 CIMIA2 */
#define TINTNO_CIMIB2		41U		/* 8 bit timer 2 CIMIB2 */
#define TINTNO_CIMIA3		42U		/* 8 bit timer 3 CIMIA3 */
#define TINTNO_CIMIB3		42U		/* 8 bit timer 3 CIMIB3 */
#define TINTNO_TOVI2		43U		/* 8 bit timer 2 TOVI2  */
#define TINTNO_TOVI3		43U		/* 8 bit timer 3 TOVI3  */

#define TINTNO_DEND0A       44U     /* DMAC */
#define TINTNO_DEND0B       45U     /* DMAC */
#define TINTNO_DEND1A       46U     /* DMAC */
#define TINTNO_DEND1B       47U     /* DMAC */

#define TINTNO_ERI0         52U     /* SCI0 ERI */
#define TINTNO_RXI0         53U     /* SCI0 RXI */
#define TINTNO_TXI0         54U     /* SCI0 TXI */
#define TINTNO_TEI0         55U     /* SCI0 TEI */

#define TINTNO_ERI1         56U     /* SCI1 ERI */
#define TINTNO_RXI1         57U     /* SCI1 RXI */
#define TINTNO_TXI1         58U     /* SCI1 TXI */
#define TINTNO_TEI1         59U     /* SCI1 TEI */

#define TINTNO_ERI2			60U		/* SCI2 ERI */
#define TINTNO_RXI2			61U		/* SCI2 RXI */
#define TINTNO_TXI2			62U		/* SCI2 TXI */
#define TINTNO_TEI2			63U		/* SCI2 TEI */

/* 
 * register address 
 *I/O쥸(1) 0xee,00000xee,00ff
 *I/O쥸(2) 0xff,ff200xff,ffe9
 *ޥ˥奢ˤϲ2ХȤܤƤʤΤ
 *1ХȤ䤦
 */

/* I/O ports */

/* port1: A0  - A7  */

#define H8P1DDR             0xfee000UL
#define H8P1DR              0xffffd0UL

/* port2: A8  - A15 */

#define H8P2DDR             0xfee001UL
#define H8P2DR              0xffffd1UL
#define H8P2PCR             0xfee03cUL

/* port3: D8  - D15 */

#define H8P3DDR             0xfee002UL
#define H8P3DR              0xffffd2UL

/* port4: D0  - D7  */

#define H8P4DDR             0xfee003UL
#define H8P4DR              0xffffd3UL
#define H8P4PCR             0xfee03eUL

/* port5: A16 - A19 */

#define H8P5DDR             0xfee004UL
#define H8P5DR              0xffffd4UL
#define H8P5PCR             0xfee03fUL

#define H8P5DDR_A19_BIT     3U
#define H8P5DDR_A18_BIT     2U
#define H8P5DDR_A17_BIT     1U
#define H8P5DDR_A16_BIT     0U

#define H8P5DDR_A19         (1U<<H8P5DDR_A19_BIT)
#define H8P5DDR_A18         (1U<<H8P5DDR_A18_BIT)
#define H8P5DDR_A17         (1U<<H8P5DDR_A17_BIT)
#define H8P5DDR_A16         (1U<<H8P5DDR_A16_BIT)

/* port6 */

#define H8P6DDR             0xfee005UL
#define H8P6DR              0xffffd5UL

#define H8P6DDR_CLOCK_BIT   7U
#define H8P6DDR_HWR_BIT     6U
#define H8P6DDR_LWR_BIT     5U
#define H8P6DDR_RD_BIT      4U
#define H8P6DDR_AS_BIT      3U
#define H8P6DDR_BACK_BIT    2U
#define H8P6DDR_BREQ_BIT    1U
#define H8P6DDR_WAIT_BIT    0U

#define H8P6DDR_CLOCK       (1U<<H8P6DDR_CLOCK_BIT)
#define H8P6DDR_HWR         (1U<<H8P6DDR_HWR_BIT)
#define H8P6DDR_LWR         (1U<<H8P6DDR_LWR_BIT)
#define H8P6DDR_RD          (1U<<H8P6DDR_RD_BIT)
#define H8P6DDR_AS          (1U<<H8P6DDR_AS_BIT)
#define H8P6DDR_BACK        (1U<<H8P6DDR_BACK_BIT)
#define H8P6DDR_BREQ        (1U<<H8P6DDR_BREQ_BIT)
#define H8P6DDR_WAIT        (1U<<H8P6DDR_WAIT_BIT)

/* port7 */

#define H8P7DR              0xffffd6UL

/* port8 */

#define H8P8DDR             0xfee007UL
#define H8P8DR              0xffffd7UL

#define H8P8DDR_CS0_BIT     4U
#define H8P8DDR_CS1_BIT     3U
#define H8P8DDR_CS2_BIT     2U
#define H8P8DDR_CS3_BIT     1U
#define H8P8DDR_RFSH_BIT    0U

#define H8P8DDR_CS0         (1U<<H8P8DDR_CS0_BIT)
#define H8P8DDR_CS1         (1U<<H8P8DDR_CS1_BIT)
#define H8P8DDR_CS2         (1U<<H8P8DDR_CS2_BIT)
#define H8P8DDR_CS3         (1U<<H8P8DDR_CS3_BIT)
#define H8P8DDR_RFSH        (1U<<H8P8DDR_RFSH_BIT)

#define H8P8DDR_IRQ3_BIT    3U
#define H8P8DDR_IRQ2_BIT    2U
#define H8P8DDR_IRQ1_BIT    1U
#define H8P8DDR_IRQ0_BIT    0U

#define H8P8DDR_IRQ3        (1U<<H8P8DDR_IRQ3_BIT)
#define H8P8DDR_IRQ2        (1U<<H8P8DDR_IRQ2_BIT)
#define H8P8DDR_IRQ1        (1U<<H8P8DDR_IRQ1_BIT)
#define H8P8DDR_IRQ0        (1U<<H8P8DDR_IRQ0_BIT)

#define H8P8DDR_ADTRG_BIT   3U

#define H8P8DDR_ADTRG       (1U<<H8PBDDR_ADTRG_BIT)

/* port9 (SCI) */

#define H8P9DDR             0xfee008UL
#define H8P9DR              0xffffd8UL

#define H8P9DDR_SCK1_BIT    5U
#define H8P9DDR_SCK0_BIT    4U
#define H8P9DDR_RXD1_BIT    3U
#define H8P9DDR_RXD0_BIT    2U
#define H8P9DDR_TXD1_BIT    1U
#define H8P9DDR_TXD0_BIT    0U

#define H8P9DDR_SCK1        (1U<<H8P9DDR_SCK1_BIT)
#define H8P9DDR_SCK0        (1U<<H8P9DDR_SCK0_BIT)
#define H8P9DDR_RXD1        (1U<<H8P9DDR_RXD1_BIT)
#define H8P9DDR_RXD0        (1U<<H8P9DDR_RXD0_BIT)
#define H8P9DDR_TXD1        (1U<<H8P9DDR_TXD1_BIT)
#define H8P9DDR_TXD0        (1U<<H8P9DDR_TXD0_BIT)

#define H8P9DDR_IRQ5_BIT    5U
#define H8P9DDR_IRQ4_BIT    4U

#define H8P9DDR_IRQ5        (1U<<H8P9DDR_IRQ5_BIT)
#define H8P9DDR_IRQ4        (1U<<H8P9DDR_IRQ4_BIT)

/* portA (TPC/ITU/DMA) */

#define H8PADDR             0xfee009UL
#define H8PADR              0xffffd9UL

#define H8PADDR_TP7_BIT     7U
#define H8PADDR_TP6_BIT     6U
#define H8PADDR_TP5_BIT     5U
#define H8PADDR_TP4_BIT     4U
#define H8PADDR_TP3_BIT     3U
#define H8PADDR_TP2_BIT     2U
#define H8PADDR_TP1_BIT     1U
#define H8PADDR_TP0_BIT     0U

#define H8PADDR_TP7         (1U<<H8PADDR_TP7_BIT)
#define H8PADDR_TP6         (1U<<H8PADDR_TP6_BIT)
#define H8PADDR_TP5         (1U<<H8PADDR_TP5_BIT)
#define H8PADDR_TP4         (1U<<H8PADDR_TP4_BIT)
#define H8PADDR_TP3         (1U<<H8PADDR_TP3_BIT)
#define H8PADDR_TP2         (1U<<H8PADDR_TP2_BIT)
#define H8PADDR_TP1         (1U<<H8PADDR_TP1_BIT)
#define H8PADDR_TP0         (1U<<H8PADDR_TP0_BIT)

#define H8PADDR_TIOCB2_BIT  7U
#define H8PADDR_TIOCA2_BIT  6U
#define H8PADDR_TIOCB1_BIT  5U
#define H8PADDR_TIOCA1_BIT  4U
#define H8PADDR_TIOCB0_BIT  3U
#define H8PADDR_TIOCA0_BIT  2U

#define H8PADDR_TIOCB2      (1U<<H8PADDR_TIOCB2_BIT)
#define H8PADDR_TIOCA2      (1U<<H8PADDR_TIOCA2_BIT)
#define H8PADDR_TIOCB1      (1U<<H8PADDR_TIOCB1_BIT)
#define H8PADDR_TIOCA1      (1U<<H8PADDR_TIOCA1_BIT)
#define H8PADDR_TIOCB0      (1U<<H8PADDR_TIOCB0_BIT)
#define H8PADDR_TIOCA0      (1U<<H8PADDR_TIOCA0_BIT)

#define H8PADDR_TEND1_BIT   1U
#define H8PADDR_TEND0_BIT   0U

#define H8PADDR_TEND1       (1U<<H8PADDR_TEND1_BIT)
#define H8PADDR_TEND0       (1U<<H8PADDR_TEND0_BIT)

#define H8PADDR_A20_BIT     7U
#define H8PADDR_A21_BIT     6U
#define H8PADDR_A22_BIT     5U
#define H8PADDR_A23_BIT     4U

#define H8PADDR_A20         (1U<<H8PADDR_A20_BIT)
#define H8PADDR_A21         (1U<<H8PADDR_A21_BIT)
#define H8PADDR_A22         (1U<<H8PADDR_A22_BIT)
#define H8PADDR_A23         (1U<<H8PADDR_A23_BIT)

#define H8PADDR_TCLKD_BIT   3U
#define H8PADDR_TCLKC_BIT   2U
#define H8PADDR_TCLKB_BIT   1U
#define H8PADDR_TCLKA_BIT   0U

#define H8PADDR_TCLKD       (1U<<H8PADDR_TCLKD_BIT)
#define H8PADDR_TCLKC       (1U<<H8PADDR_TCLKC_BIT)
#define H8PADDR_TCLKB       (1U<<H8PADDR_TCLKB_BIT)
#define H8PADDR_TCLKA       (1U<<H8PADDR_TCLKA_BIT)

/* portB (TP/ITU/DMA/AD) */

#define H8PBDDR             0xfee00aUL
#define H8PBDR              0xffffdaUL

#define H8PBDDR_TP15_BIT    7U
#define H8PBDDR_TP14_BIT    6U
#define H8PBDDR_TP13_BIT    5U
#define H8PBDDR_TP12_BIT    4U
#define H8PBDDR_TP11_BIT    3U
#define H8PBDDR_TP10_BIT    2U
#define H8PBDDR_TP9_BIT     1U
#define H8PBDDR_TP8_BIT     0U

#define H8PBDDR_TP15        (1U<<H8PBDDR_TP15_BIT)
#define H8PBDDR_TP14        (1U<<H8PBDDR_TP14_BIT)
#define H8PBDDR_TP13        (1U<<H8PBDDR_TP13_BIT)
#define H8PBDDR_TP12        (1U<<H8PBDDR_TP12_BIT)
#define H8PBDDR_TP11        (1U<<H8PBDDR_TP11_BIT)
#define H8PBDDR_TP10        (1U<<H8PBDDR_TP10_BIT)
#define H8PBDDR_TP9         (1U<<H8PBDDR_TP9_BIT)
#define H8PBDDR_TP8         (1U<<H8PBDDR_TP8_BIT)

#define H8PBDDR_LCAS_BIT    5U
#define H8PBDDR_UCAS_BIT    4U
#define H8PBDDR_DREQ1_BIT   3U
#define H8PBDDR_DREQ0_BIT   1U

#define H8PBDDR_LCAS        (1U<<H8PBDDR_LCAS_BIT)
#define H8PBDDR_UCAS        (1U<<H8PBDDR_UCAS_BIT)
#define H8PBDDR_DREQ1       (1U<<H8PBDDR_DREQ1_BIT)
#define H8PBDDR_DREQ0       (1U<<H8PBDDR_DREQ0_BIT)

#define H8PBDDR_TMIO3_BIT   3U
#define H8PBDDR_TMIO2_BIT   2U
#define H8PBDDR_TMIO1_BIT   1U
#define H8PBDDR_TMIO0_BIT   0U

#define H8PBDDR_TMIO4       (1U<<H8PBDDR_TMIO3_BIT)
#define H8PBDDR_TMIO3       (1U<<H8PBDDR_TMIO2_BIT)
#define H8PBDDR_TMIO2       (1U<<H8PBDDR_TMIO1_BIT)
#define H8PBDDR_TMIO1       (1U<<H8PBDDR_TMIO0_BIT)

#define H8PBDDR_RXD2_BIT    7U
#define H8PBDDR_TXD2_BIT    6U
#define H8PBDDR_SCK2_BIT    5U

#define H8PBDDR_RXD2        (1U<<H8PBDDR_RXD2_BIT)
#define H8PBDDR_TXD2        (1U<<H8PBDDR_TXD2_BIT)
#define H8PBDDR_SCK2        (1U<<H8PBDDR_SCK2_BIT)

#define H8PBDDR_CS4_BIT     3U
#define H8PBDDR_CS5_BIT     2U
#define H8PBDDR_CS6_BIT     1U
#define H8PBDDR_CS7_BIT     0U

#define H8PBDDR_CS4         (1U<<H8PBDDR_CS4_BIT)
#define H8PBDDR_CS5         (1U<<H8PBDDR_CS5_BIT)
#define H8PBDDR_CS6         (1U<<H8PBDDR_CS6_BIT)
#define H8PBDDR_CS7         (1U<<H8PBDDR_CS7_BIT)

/* Interrupt Contolller */

#define H8INTC              0xfee014UL  /* interrupt controller base address */
#define H8ISCR              0xfee014UL
#define H8IER               0xfee015UL
#define H8ISR               0xfee016UL
#define H8IPRA              0xfee018UL
#define H8IPRB              0xfee019UL

/* System Control Register */

#define H8SYSCR             0xfee012UL  /* SYSCR */

#define H8SYSCR_SSBY_BIT    7U
#define H8SYSCR_STS2_BIT    6U
#define H8SYSCR_STS1_BIT    5U
#define H8SYSCR_STS0_BIT    4U
#define H8SYSCR_UE_BIT      3U
#define H8SYSCR_NMIEG_BIT   2U
#define H8SYSCR_SSOE_BIT    1U
#define H8SYSCR_RAME_BIT    0U

#define H8SYSCR_SSBY        (1U<<(H8SYSCR_SSBY_BIT))
#define H8SYSCR_STS2        (1U<<(H8SYSCR_STS2_BIT))
#define H8SYSCR_STS1        (1U<<(H8SYSCR_STS1_BIT))
#define H8SYSCR_STS0        (1U<<(H8SYSCR_STS0_BIT))
#define H8SYSCR_UE          (1U<<(H8SYSCR_UE_BIT))
#define H8SYSCR_NMIEG       (1U<<(H8SYSCR_NMIEG_BIT))
#define H8SYSCR_SSOE        (1U<<(H8SYSCR_SSOE_BIT))
#define H8SYSCR_RAME        (1U<<(H8SYSCR_RAME_BIT))

/* Interrupt Enable Register */

#define H8IER_IRQ5E_BIT     5U	/* IRQ5			*/
#define H8IER_IRQ4E_BIT     4U	/* IRQ4			*/
#define H8IER_IRQ3E_BIT     3U	/* IRQ3			*/
#define H8IER_IRQ2E_BIT     2U	/* IRQ2			*/
#define H8IER_IRQ1E_BIT     1U	/* IRQ1			*/
#define H8IER_IRQ0E_BIT     0U	/* IRQ0			*/

/* Interrupt Priority Register A */

#define H8IPR_IRQ0_BIT      7U	/* IRQ0			*/
#define H8IPR_IRQ1_BIT      6U	/* IRQ1			*/
#define H8IPR_IRQ2_BIT      5U	/* IRQ2			*/
#define H8IPR_IRQ3_BIT      5U	/* IRQ3			*/
#define H8IPR_IRQ4_BIT      4U	/* IRQ4			*/
#define H8IPR_IRQ5_BIT      4U	/* IRQ5			*/
#define H8IPR_WDT_BIT       3U	/* WDT			*/
#define H8IPR_AD_BIT        3U	/* A/D			*/
#define H8IPR_CMI_BIT       3U	/* CMI			*/
#define H8IPR_ITU0_BIT      2U	/* 16 bit timer 0	*/
#define H8IPR_ITU1_BIT      1U	/* 16 bit timer 1	*/
#define H8IPR_ITU2_BIT      0U	/* 16 bit timer 2	*/

#define H8IPR_IRQ0          (1U<<(H8IPR_IRQ0_BIT))
#define H8IPR_IRQ1          (1U<<(H8IPR_IRQ1_BIT))
#define H8IPR_IRQ2          (1U<<(H8IPR_IRQ2_BIT))
#define H8IPR_IRQ3          (1U<<(H8IPR_IRQ3_BIT))
#define H8IPR_IRQ4          (1U<<(H8IPR_IRQ4_BIT))
#define H8IPR_IRQ5          (1U<<(H8IPR_IRQ5_BIT))
#define H8IPR_WDT           (1U<<(H8IPR_WDT_BIT))
#define H8IPR_AD            (1U<<(H8IPR_AD_BIT))
#define H8IPR_CMI           (1U<<(H8IPR_CMI_BIT))
#define H8IPR_ITU0          (1U<<(H8IPR_ITU0_BIT))
#define H8IPR_ITU1          (1U<<(H8IPR_ITU1_BIT))
#define H8IPR_ITU2          (1U<<(H8IPR_ITU2_BIT))

/*	Bus Release Control Regisger	*/

#define H8BRCR              0xfee013UL

/*	Control bit in BRCR		*/

#define H8BRCR_A23E_BIT     7U
#define H8BRCR_A22E_BIT     6U
#define H8BRCR_A21E_BIT     5U
#define H8BRCR_BRLE_BIT     1U

#define H8BRCR_A23E         (1U<<(H8BRCR_A23E_BIT))
#define H8BRCR_A22E         (1U<<(H8BRCR_A22E_BIT))
#define H8BRCR_A21E         (1U<<(H8BRCR_A21E_BIT))
#define H8BRCR_BRLE         (1U<<(H8BRCR_BRLE_BIT))

/* Interrupt Priority Register B */

#define H8IPR_TU80_BIT      7U	/* 8 bit timer 0	*/
#define H8IPR_TU81_BIT      6U	/* 8 bit timer 1	*/
#define H8IPR_DMAC_BIT      5U	/* DMAC (CH0,1)		*/
#define H8IPR_SCI0_BIT      3U	/* SCI0			*/
#define H8IPR_SCI1_BIT      2U	/* SCI1			*/
#define H8IPR_SCI2_BIT      1U	/* SCI2			*/

#define H8IPR_TU80          (1U<<(H8IPR_TU80_BIT))
#define H8IPR_TU81          (1U<<(H8IPR_TU81_BIT))
#define H8IPR_DMAC          (1U<<(H8IPR_DMAC_BIT))
#define H8IPR_SCI0          (1U<<(H8IPR_SCI0_BIT))
#define H8IPR_SCI1          (1U<<(H8IPR_SCI1_BIT))
#define H8IPR_SCI2          (1U<<(H8IPR_SCI2_BIT))

/* 16 bit Timer */
#define TOPPERS_H8_16TU

#define H816TU              0xffff60UL	/* base address */
#define H816TU_TSTR         0xffff60UL
#define H816TU_TSNC         0xffff61UL
#define H816TU_TMDR         0xffff62UL
#define H816TU_TOLR         0xffff63UL
#define H816TU_TISRA        0xffff64UL
#define H816TU_TISRB        0xffff65UL
#define H816TU_TISRC        0xffff66UL

#define H816TU0             0xffff68UL	/* base address */
#define H816TU1             0xffff70UL	/* base address */
#define H816TU2             0xffff78UL	/* base address */

/* address offset */

#define H8TCR               0U
#define H8TIOR              1U
#define H8TCNT              2U
#define H8TCNTH             2U
#define H8TCNTL             3U
#define H8GRA               4U
#define H8GRAH              4U
#define H8GRAL              5U
#define H8GRB               6U
#define H8GRBH              6U
#define H8GRBL              7U

/* Timer Start Register (TSTR) */

#define H8TSTR_STR2_BIT     2U
#define H8TSTR_STR1_BIT     1U
#define H8TSTR_STR0_BIT     0U

#define H8TSTR_STR2         (1U<<H8TSTR_STR2_BIT)
#define H8TSTR_STR1         (1U<<H8TSTR_STR1_BIT)
#define H8TSTR_STR0         (1U<<H8TSTR_STR0_BIT)

/* Timer Synchronous Register (TSNC) */

#define H8TSNC_SYNC2_BIT    2U
#define H8TSNC_SYNC1_BIT    1U
#define H8TSNC_SYNC0_BIT    0U

#define H8TSNC_SYNC2        (1U<<H8TSNC_SYNC2_BIT)
#define H8TSNC_SYNC1        (1U<<H8TSNC_SYNC1_BIT)
#define H8TSNC_SYNC0        (1U<<H8TSNC_SYNC0_BIT)

/* Timer Mode Register (TMDR) */

#define H8TMDR_MDF_BIT      6U
#define H8TMDR_FDIR_BIT     5U
#define H8TMDR_PWM2_BIT     2U
#define H8TMDR_PWM1_BIT     1U
#define H8TMDR_PWM0_BIT     0U

#define H8TMDR_MDF          (1U<<H8TMDR_MDF_BIT)
#define H8TMDR_FDIR         (1U<<H8TMDR_FDIR_BIT)
#define H8TMDR_PWM2         (1U<<H8TMDR_PWM2_BIT)
#define H8TMDR_PWM1         (1U<<H8TMDR_PWM1_BIT)
#define H8TMDR_PWM0         (1U<<H8TMDR_PWM0_BIT)

/* Timer Interrupt Status Register A (TISRA) */

#define H8TISRA_IMIEA2_BIT  6U
#define H8TISRA_IMIEA1_BIT  5U
#define H8TISRA_IMIEA0_BIT  4U
#define H8TISRA_IMFA2_BIT   2U
#define H8TISRA_IMFA1_BIT   1U
#define H8TISRA_IMFA0_BIT   0U

#define H8TISRA_IMIEA2      (1U<<H8TISRA_IMIEA2_BIT)
#define H8TISRA_IMIEA1      (1U<<H8TISRA_IMIEA1_BIT)
#define H8TISRA_IMIEA0      (1U<<H8TISRA_IMIEA0_BIT)
#define H8TISRA_IMFA2       (1U<<H8TISRA_IMFA2_BIT)
#define H8TISRA_IMFA1       (1U<<H8TISRA_IMFA1_BIT)
#define H8TISRA_IMFA0       (1U<<H8TISRA_IMFA0_BIT)

/* Timer Interrupt Status Register B (TISRB) */

#define H8TISRB_IMIEA2_BIT  6U
#define H8TISRB_IMIEA1_BIT  5U
#define H8TISRB_IMIEA0_BIT  4U
#define H8TISRB_IMFA2_BIT   2U
#define H8TISRB_IMFA1_BIT   1U
#define H8TISRB_IMFA0_BIT   0U

#define H8TISRB_IMIEA2      (1U<<H8TISRB_IMIEA2_BIT)
#define H8TISRB_IMIEA1      (1U<<H8TISRB_IMIEA1_BIT)
#define H8TISRB_IMIEA0      (1U<<H8TISRB_IMIEA0_BIT)
#define H8TISRB_IMFA2       (1U<<H8TISRB_IMFA2_BIT)
#define H8TISRB_IMFA1       (1U<<H8TISRB_IMFA1_BIT)
#define H8TISRB_IMFA0       (1U<<H8TISRB_IMFA0_BIT)

/* Timer Interrupt Status Register C (TISRC) */

#define H8TISRC_OVIEA2_BIT  6U
#define H8TISRC_OVIEA1_BIT  5U
#define H8TISRC_OVIEA0_BIT  4U
#define H8TISRC_OVFA2_BIT   2U
#define H8TISRC_OVFA1_BIT   1U
#define H8TISRC_OVFA0_BIT   0U

#define H8TISRC_OVIEA2      (1U<<H8TISRC_OVIEA2_BIT)
#define H8TISRC_OVIEA1      (1U<<H8TISRC_OVIEA1_BIT)
#define H8TISRC_OVIEA0      (1U<<H8TISRC_OVIEA0_BIT)
#define H8TISRC_OVFA2       (1U<<H8TISRC_OVFA2_BIT)
#define H8TISRC_OVFA1       (1U<<H8TISRC_OVFA1_BIT)
#define H8TISRC_OVFA0       (1U<<H8TISRC_OVFA0_BIT)

/* Timer Control Register (TCR) */

#define H8TCR_CCLR1_BIT     6U
#define H8TCR_CCLR0_BIT     5U
#define H8TCR_CKEG1_BIT     4U
#define H8TCR_CKEG0_BIT     3U
#define H8TCR_TPSC2_BIT     2U
#define H8TCR_TPSC1_BIT     1U
#define H8TCR_TPSC0_BIT     0U

#define H8TCR_CCLR1         (1U<<H8TCR_CCLR1_BIT)
#define H8TCR_CCLR0         (1U<<H8TCR_CCLR0_BIT)
#define H8TCR_CKEG1         (1U<<H8TCR_CKEG1_BIT)
#define H8TCR_CKEG0         (1U<<H8TCR_CKEG0_BIT)
#define H8TCR_TPSC2         (1U<<H8TCR_TPSC2_BIT)
#define H8TCR_TPSC1         (1U<<H8TCR_TPSC1_BIT)
#define H8TCR_TPSC0         (1U<<H8TCR_TPSC0_BIT)

/* Timer I/O Control Register (TIOR) */

#define H8TIOR_IOB2_BIT     6U
#define H8TIOR_IOB1_BIT     5U
#define H8TIOR_IOB0_BIT     4U
#define H8TIOR_IOA2_BIT     2U
#define H8TIOR_IOA1_BIT     1U
#define H8TIOR_IOA0_BIT     0U

#define H8TIOR_IOB2         (1U<<H8TIOR_IOB2_BIT)
#define H8TIOR_IOB1         (1U<<H8TIOR_IOB1_BIT)
#define H8TIOR_IOB0         (1U<<H8TIOR_IOB0_BIT)
#define H8TIOR_IOA2         (1U<<H8TIOR_IOA2_BIT)
#define H8TIOR_IOA1         (1U<<H8TIOR_IOA1_BIT)
#define H8TIOR_IOA0         (1U<<H8TIOR_IOA0_BIT)

/* 8 bit Timer */

#define H88TU0              0xffff80UL	/* base address */
#define H88TU1              0xffff81UL
#define H88TU2              0xffff90UL
#define H88TU3              0xffff91UL

/* address offset */

#define H88TCR              0U
#define H88TCSR             2U
#define H88TCORA            4U
#define H88TCORB            6U
#define H88TCNT             8U

/* 8 Bit Timer Control Register (8TCR) */

#define H88TCR_CMIEB_BIT    7U
#define H88TCR_CMIEA_BIT    6U
#define H88TCR_OVIE_BIT     5U
#define H88TCR_CCLR1_BIT    4U
#define H88TCR_CCLR0_BIT    3U
#define H88TCR_CKS2_BIT     2U
#define H88TCR_CKS1_BIT     1U
#define H88TCR_CKS0_BIT     0U

#define H88TCR_CMIEB        (1U<<H88TCR_CMIEB_BIT)
#define H88TCR_CMIEA        (1U<<H88TCR_CMIEA_BIT)
#define H88TCR_OVIE         (1U<<H88TCR_OVIE_BIT)
#define H88TCR_CCLR1        (1U<<H88TCR_CCLR1_BIT)
#define H88TCR_CCLR0        (1U<<H88TCR_CCLR0_BIT)
#define H88TCR_CKS2         (1U<<H88TCR_CKS2_BIT)
#define H88TCR_CKS1         (1U<<H88TCR_CKS1_BIT)
#define H88TCR_CKS0         (1U<<H88TCR_CKS0_BIT)

/* 8 Bit Timer Control/Status Register (8TCSR) */

#define H88TCSR_CMFB_BIT    7U
#define H88TCSR_CMFA_BIT    6U
#define H88TCSR_OVF_BIT     5U
#define H88TCSR_ADTE_BIT    4U
#define H88TCSR_ICE_BIT     4U
#define H88TCSR_OIS3_BIT    3U
#define H88TCSR_OIS2_BIT    2U
#define H88TCSR_OS1_BIT     1U
#define H88TCSR_OS0_BIT     0U

#define H88TCSR_CMFB        (1U<<H88TCSR_CMFB_BIT)
#define H88TCSR_CMFA        (1U<<H88TCSR_CMFA_BIT)
#define H88TCSR_OVF         (1U<<H88TCSR_OVF_BIT)
#define H88TCSR_ADTE        (1U<<H88TCSR_ADTE_BIT)
#define H88TCSR_ICE         (1U<<H88TCSR_ICE_BIT)
#define H88TCSR_OIS3        (1U<<H88TCSR_OIS3_BIT)
#define H88TCSR_OIS2        (1U<<H88TCSR_OIS2_BIT)
#define H88TCSR_OS1         (1U<<H88TCSR_OS1_BIT)
#define H88TCSR_OS0         (1U<<H88TCSR_OS0_BIT)

/* Serial Communication Interface (SCI) */

#define H8SCI0              0xffffb0UL	/* base address */
#define H8SCI1              0xffffb8UL
#define H8SCI2              0xffffc0UL

/* address offset */

#define H8SMR               0U
#define H8BRR               1U
#define H8SCR               2U
#define H8TDR               3U
#define H8SSR               4U
#define H8RDR               5U
#define H8SCMR              6U

/* SCI Serial Mode Register (SMR) */

#define H8SMR_GM_BIT        7U
#define H8SMR_CHR_BIT       6U
#define H8SMR_PE_BIT        5U
#define H8SMR_OE_BIT        4U
#define H8SMR_STOP_BIT      3U
#define H8SMR_MP_BIT        2U
#define H8SMR_CKS1_BIT      1U
#define H8SMR_CKS0_BIT      0U

#define H8SMR_GM            (1U<<H8SMR_GM_BIT)
#define H8SMR_CHR           (1U<<H8SMR_CHR_BIT)
#define H8SMR_PE            (1U<<H8SMR_PE_BIT)
#define H8SMR_OE            (1U<<H8SMR_OE_BIT)
#define H8SMR_STOP          (1U<<H8SMR_STOP_BIT)
#define H8SMR_MP            (1U<<H8SMR_MP_BIT)
#define H8SMR_CKS1          (1U<<H8SMR_CKS1_BIT)
#define H8SMR_CKS0          (1U<<H8SMR_CKS0_BIT)
#define H8SMR_CKS_MASK      (H8SMR_CKS1|H8SMR_CKS0)

/* SCI Serial Control Register (SCR) */

#define H8SCR_TIE_BIT       7U
#define H8SCR_RIE_BIT       6U
#define H8SCR_TE_BIT        5U
#define H8SCR_RE_BIT        4U
#define H8SCR_MPIE_BIT      3U
#define H8SCR_TEIE_BIT      2U
#define H8SCR_CKE1_BIT      1U
#define H8SCR_CKE0_BIT      0U

#define H8SCR_TIE           (1U<<H8SCR_TIE_BIT)
#define H8SCR_RIE           (1U<<H8SCR_RIE_BIT)
#define H8SCR_TE            (1U<<H8SCR_TE_BIT)
#define H8SCR_RE            (1U<<H8SCR_RE_BIT)
#define H8SCR_MPIE          (1U<<H8SCR_MPIE_BIT)
#define H8SCR_TEIE          (1U<<H8SCR_TEIE_BIT)
#define H8SCR_CKE1          (1U<<H8SCR_CKE1_BIT)
#define H8SCR_CKE0          (1U<<H8SCR_CKE0_BIT)
#define H8SCR_CKE_MASK      (H8SCR_CKE1|H8SCR_CKE0)
#define H8SCR_IE            (H8SCR_TIE|H8SCR_RIE|H8SCR_MPIE|H8SCR_TEIE)

/* SCI Serial Status Register (SSR) */

#define H8SSR_TDRE_BIT      7U
#define H8SSR_RDRF_BIT      6U
#define H8SSR_ORER_BIT      5U
#define H8SSR_FER_BIT       4U
#define H8SSR_PER_BIT       3U
#define H8SSR_TEND_BIT      2U
#define H8SSR_MPB_BIT       1U
#define H8SSR_MPBT_BIT      0U

#define H8SSR_TDRE          (1U<<H8SSR_TDRE_BIT)
#define H8SSR_RDRF          (1U<<H8SSR_RDRF_BIT)
#define H8SSR_ORER          (1U<<H8SSR_ORER_BIT)
#define H8SSR_FER           (1U<<H8SSR_FER_BIT)
#define H8SSR_PER           (1U<<H8SSR_PER_BIT)
#define H8SSR_TEND          (1U<<H8SSR_TEND_BIT)
#define H8SSR_MPB           (1U<<H8SSR_MPB_BIT)
#define H8SSR_MPBT          (1U<<H8SSR_MPBT_BIT)

/* DRAM Control Registers */

#define H8DRCRA             0xfee026UL	/* Control Register A			*/
#define H8DRCRB             0xfee027UL	/* Control Register B			*/
#define H8RTMCSR            0xfee028UL	/* Timer Control / Status Register	*/
#define H8RTCNT             0xfee029UL	/* Reflesh Timer Counter		*/
#define H8RTCOR             0xfee02aUL	/* Reflesh Time Constant Register	*/

/* DRAM Control Register A */

#define H8DRCRA_DRAS2_BIT   7U
#define H8DRCRA_DRAS1_BIT   6U
#define H8DRCRA_DRAS0_BIT   5U
#define H8DRCRA_BE_BIT      3U
#define H8DRCRA_RDM_BIT     2U
#define H8DRCRA_SRFMD_BIT   1U
#define H8DRCRA_RFSHE_BIT   0U

#define H8DRCRA_DRAS2       (1U<<H8DRCRA_DRAS2_BIT)
#define H8DRCRA_DRAS1       (1U<<H8DRCRA_DRAS1_BIT)
#define H8DRCRA_DRAS0       (1U<<H8DRCRA_DRAS0_BIT)
#define H8DRCRA_BE          (1U<<H8DRCRA_BE_BIT)
#define H8DRCRA_RDM         (1U<<H8DRCRA_RDM_BIT)
#define H8DRCRA_SRFMD       (1U<<H8DRCRA_SRFMD_BIT)
#define H8DRCRA_RFSHE       (1U<<H8DRCRA_RFSHE_BIT)

/* DRAM Control Register B */

#define H8DRCRB_MXC1_BIT    7U
#define H8DRCRB_MXC0_BIT    6U
#define H8DRCRB_CSEL_BIT    5U
#define H8DRCRB_RCYCE_BIT   4U
#define H8DRCRB_TPC_BIT     2U
#define H8DRCRB_RCW_BIT     1U
#define H8DRCRB_RLW_BIT     0U

#define H8DRCRB_MXC1        (1U<<H8DRCRB_MXC1_BIT)
#define H8DRCRB_MXC0        (1U<<H8DRCRB_MXC0_BIT)
#define H8DRCRB_CSEL        (1U<<H8DRCRB_CSEL_BIT)
#define H8DRCRB_RCYCE       (1U<<H8DRCRB_RCYCE_BIT)
#define H8DRCRB_TPC         (1U<<H8DRCRB_TPC_BIT)
#define H8DRCRB_RCW         (1U<<H8DRCRB_RCW_BIT)
#define H8DRCRB_RLW         (1U<<H8DRCRB_RLW_BIT)

/* Reflesh Timer Control / Status Register */

#define H8RTMCSR_CMF_BIT    7U
#define H8RTMCSR_CMIE_BIT   6U
#define H8RTMCSR_CKS2_BIT   5U
#define H8RTMCSR_CKS1_BIT   4U
#define H8RTMCSR_CKS0_BIT   3U

#define H8RTMCSR_CMF        (1U<<H8RTMCSR_CMF_BIT)
#define H8RTMCSR_CMIE       (1U<<H8RTMCSR_CMIE_BIT)
#define H8RTMCSR_CKS2       (1U<<H8RTMCSR_CKS2_BIT)
#define H8RTMCSR_CKS1       (1U<<H8RTMCSR_CKS1_BIT)
#define H8RTMCSR_CKS0       (1U<<H8RTMCSR_CKS0_BIT)

/*
 *  ¢
 */

#define H8IN_ROM_BASE       0x000000UL
#define H8IN_ROM_SIZE       0x080000UL
#define H8IN_RAM_BASE       0xffbf10UL
#define H8IN_RAM_SIZE       0x004000UL

#endif /* TOPPERS_H8_3069F_H_ */
